/*
 * Interface wrapper code.
 *
 * Generated by SIP 6.8.3
 *
 *     Copyright: (c) 2020 by Total Control Software
 *     License:   wxWindows License
 */

#include "sipAPI_core.h"
        
        typedef wxList wxCommandList;
        #include <wx/cmdproc.h>
        
        typedef wxList wxCommandList;
        class wxCommandList_iterator {
        public:
            wxCommandList_iterator(wxCommandList::compatibility_iterator start)
                : m_node(start) {}

            wxCommand* __next__() {
                wxCommand* obj = NULL;
                if (m_node) {
                    obj = (wxCommand*) m_node->GetData();
                    m_node = m_node->GetNext();
                }
                else {
                    PyErr_SetString(PyExc_StopIteration, "");
                }
                return (wxCommand*)obj;
            }
        private:
            wxCommandList::compatibility_iterator m_node;
        };


PyDoc_STRVAR(doc_wxCommandList_index, "index(self, obj: Optional[Command]) -> int");

extern "C" {static PyObject *meth_wxCommandList_index(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxCommandList_index(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = SIP_NULLPTR;

    {
        ::wxCommand* obj;
        ::wxCommandList *sipCpp;

        static const char *sipKwdList[] = {
            sipName_obj,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, SIP_NULLPTR, "BJ8", &sipSelf, sipType_wxCommandList, &sipCpp, sipType_wxCommand, &obj))
        {
            int sipRes = 0;
            sipErrorState sipError = sipErrorNone;
        int idx = sipCpp->IndexOf((wxCommand*)obj);
        if (idx == wxNOT_FOUND) {
            sipError = sipErrorFail;
            wxPyErr_SetString(PyExc_ValueError,
                              "sequence.index(x): x not in sequence");
        }
        sipRes = idx;

            if (sipError == sipErrorFail)
                return 0;

            if (sipError == sipErrorNone)
            {
            return PyLong_FromLong(sipRes);
            }

            sipAddException(sipError, &sipParseErr);
        }
    }

    sipNoMethod(sipParseErr, sipName_CommandList, sipName_index, doc_wxCommandList_index);

    return SIP_NULLPTR;
}


extern "C" {static PyObject *slot_wxCommandList___iter__(PyObject *);}
static PyObject *slot_wxCommandList___iter__(PyObject *sipSelf)
{
    ::wxCommandList *sipCpp = reinterpret_cast<::wxCommandList *>(sipGetCppPtr((sipSimpleWrapper *)sipSelf, sipType_wxCommandList));

    if (!sipCpp)
        return SIP_NULLPTR;


    {
        {
            ::wxCommandList_iterator*sipRes = 0;
        sipRes =  new wxCommandList_iterator(sipCpp->GetFirst());

            return sipConvertFromNewType(sipRes, sipType_wxCommandList_iterator, SIP_NULLPTR);
        }
    }

    return 0;
}


extern "C" {static int slot_wxCommandList___contains__(PyObject *, PyObject *);}
static int slot_wxCommandList___contains__(PyObject *sipSelf, PyObject *sipArg)
{
    ::wxCommandList *sipCpp = reinterpret_cast<::wxCommandList *>(sipGetCppPtr((sipSimpleWrapper *)sipSelf, sipType_wxCommandList));

    if (!sipCpp)
        return -1;

    PyObject *sipParseErr = SIP_NULLPTR;

    {
        const ::wxCommand* obj;

        if (sipParseArgs(&sipParseErr, sipArg, "1J8", sipType_wxCommand, &obj))
        {
            int sipRes = 0;
        wxCommandList::compatibility_iterator node;
        node = sipCpp->Find((wxCommand*)obj);
        sipRes = node != NULL;

            return sipRes;
        }
    }

    sipNoMethod(sipParseErr, sipName_CommandList, sipName___contains__, SIP_NULLPTR);

    return -1;
}


extern "C" {static PyObject *slot_wxCommandList___getitem__(PyObject *, PyObject *);}
static PyObject *slot_wxCommandList___getitem__(PyObject *sipSelf, PyObject *sipArg)
{
    ::wxCommandList *sipCpp = reinterpret_cast<::wxCommandList *>(sipGetCppPtr((sipSimpleWrapper *)sipSelf, sipType_wxCommandList));

    if (!sipCpp)
        return SIP_NULLPTR;

    PyObject *sipParseErr = SIP_NULLPTR;

    {
        long index;

        if (sipParseArgs(&sipParseErr, sipArg, "1l", &index))
        {
            ::wxCommand*sipRes = 0;
            sipErrorState sipError = sipErrorNone;
        if (0 > index)
            index += sipCpp->size();

        if (index < sipCpp->size() && (0 <= index)) {
            wxCommandList::compatibility_iterator node = sipCpp->Item(index);
            if (node)
                sipRes = (wxCommand*)node->GetData();
        }
        else {
            wxPyErr_SetString(PyExc_IndexError, "sequence index out of range");
            sipError = sipErrorFail;
        }

            if (sipError == sipErrorFail)
                return 0;

            if (sipError == sipErrorNone)
            {
            return sipConvertFromType(sipRes, sipType_wxCommand, SIP_NULLPTR);
            }

            sipAddException(sipError, &sipParseErr);
        }
    }

    sipNoMethod(sipParseErr, sipName_CommandList, sipName___getitem__, SIP_NULLPTR);

    return SIP_NULLPTR;
}


extern "C" {static Py_ssize_t slot_wxCommandList___len__(PyObject *);}
static Py_ssize_t slot_wxCommandList___len__(PyObject *sipSelf)
{
    ::wxCommandList *sipCpp = reinterpret_cast<::wxCommandList *>(sipGetCppPtr((sipSimpleWrapper *)sipSelf, sipType_wxCommandList));

    if (!sipCpp)
        return 0;


    {
        {
            Py_ssize_t sipRes = 0;
        sipRes = sipCpp->size();

            return sipRes;
        }
    }

    return 0;
}


/* Call the instance's destructor. */
extern "C" {static void release_wxCommandList(void *, int);}
static void release_wxCommandList(void *sipCppV, int)
{
    Py_BEGIN_ALLOW_THREADS

    delete reinterpret_cast<::wxCommandList *>(sipCppV);

    Py_END_ALLOW_THREADS
}


extern "C" {static void *array_wxCommandList(Py_ssize_t);}
static void *array_wxCommandList(Py_ssize_t sipNrElem)
{
    return new ::wxCommandList[sipNrElem];
}


extern "C" {static void assign_wxCommandList(void *, Py_ssize_t, void *);}
static void assign_wxCommandList(void *sipDst, Py_ssize_t sipDstIdx, void *sipSrc)
{
    reinterpret_cast<::wxCommandList *>(sipDst)[sipDstIdx] = *reinterpret_cast<::wxCommandList *>(sipSrc);
}


extern "C" {static void *copy_wxCommandList(const void *, Py_ssize_t);}
static void *copy_wxCommandList(const void *sipSrc, Py_ssize_t sipSrcIdx)
{
    return new ::wxCommandList(reinterpret_cast<const ::wxCommandList *>(sipSrc)[sipSrcIdx]);
}


extern "C" {static void dealloc_wxCommandList(sipSimpleWrapper *);}
static void dealloc_wxCommandList(sipSimpleWrapper *sipSelf)
{
    if (sipIsOwnedByPython(sipSelf))
    {
        release_wxCommandList(sipGetAddress(sipSelf), 0);
    }
}


extern "C" {static void *init_type_wxCommandList(sipSimpleWrapper *, PyObject *, PyObject *, PyObject **, PyObject **, PyObject **);}
static void *init_type_wxCommandList(sipSimpleWrapper *, PyObject *sipArgs, PyObject *sipKwds, PyObject **sipUnused, PyObject **, PyObject **sipParseErr)
{
    ::wxCommandList *sipCpp = SIP_NULLPTR;

    {
        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, SIP_NULLPTR, sipUnused, ""))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp = new ::wxCommandList();
            Py_END_ALLOW_THREADS

            return sipCpp;
        }
    }

    {
        const ::wxCommandList* a0;

        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, SIP_NULLPTR, sipUnused, "J9", sipType_wxCommandList, &a0))
        {
            Py_BEGIN_ALLOW_THREADS
            sipCpp = new ::wxCommandList(*a0);
            Py_END_ALLOW_THREADS

            return sipCpp;
        }
    }

    return SIP_NULLPTR;
}


/* Define this type's Python slots. */
static sipPySlotDef slots_wxCommandList[] = {
    {(void *)slot_wxCommandList___iter__, iter_slot},
    {(void *)slot_wxCommandList___contains__, contains_slot},
    {(void *)slot_wxCommandList___getitem__, getitem_slot},
    {(void *)slot_wxCommandList___len__, len_slot},
    {0, (sipPySlotType)0}
};


static PyMethodDef methods_wxCommandList[] = {
    {sipName_index, SIP_MLMETH_CAST(meth_wxCommandList_index), METH_VARARGS|METH_KEYWORDS, doc_wxCommandList_index}
};

PyDoc_STRVAR(doc_wxCommandList, "\1CommandList()\n"
"CommandList(a0: CommandList)");


sipClassTypeDef sipTypeDef__core_wxCommandList = {
    {
        -1,
        SIP_NULLPTR,
        SIP_NULLPTR,
        SIP_TYPE_CLASS,
        sipNameNr_wxCommandList,
        SIP_NULLPTR,
        SIP_NULLPTR,
    },
    {
        sipNameNr_CommandList,
        {0, 0, 1},
        1, methods_wxCommandList,
        0, SIP_NULLPTR,
        0, SIP_NULLPTR,
        {SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR},
    },
    doc_wxCommandList,
    -1,
    -1,
    SIP_NULLPTR,
    slots_wxCommandList,
    init_type_wxCommandList,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
    dealloc_wxCommandList,
    assign_wxCommandList,
    array_wxCommandList,
    copy_wxCommandList,
    release_wxCommandList,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
    SIP_NULLPTR,
};
